Lucene++ - a full-featured, c++ search engine
API Documentation

Public Member Functions | Static Public Member Functions | Protected Attributes
Lucene::CountingDisjunctionSumScorer Class Reference

`#include <BooleanScorer2.h>`

Inheritance diagram for Lucene::CountingDisjunctionSumScorer:

## Public Member Functions

| CountingDisjunctionSumScorer (const BooleanScorer2Ptr &scorer, Collection< ScorerPtr > subScorers, int32_t minimumNrMatchers)
virtual | ~CountingDisjunctionSumScorer ()
virtual String | getClassName ()
boost::shared_ptr< CountingDisjunctionSumScorer > | shared_from_this ()
virtual double | score ()
| Returns the score of the current document matching the query. Initially invalid, until next() is called the first time. More...
Public Member Functions inherited from Lucene::DisjunctionSumScorer
| DisjunctionSumScorer (Collection< ScorerPtr > subScorers, int32_t minimumNrMatchers=1)
virtual | ~DisjunctionSumScorer ()
boost::shared_ptr< DisjunctionSumScorer > | shared_from_this ()
virtual void | initialize ()
| Called directly after instantiation to create objects that depend on this object being fully constructed. More...
virtual void | score (const CollectorPtr &collector)
| Scores and collects all matching documents. More...
virtual int32_t | nextDoc ()
| Advances to the next document in the set and returns the doc it is currently on, or NO_MORE_DOCS if there are no more docs in the set. More...
virtual int32_t | docID ()
| Returns the following: More...
int32_t | nrMatchers ()
| Returns the number of subscorers matching the current document. Initially invalid, until next() is called the first time. More...
virtual int32_t | advance (int32_t target)
| Advances to the first match beyond the current whose document number is greater than or equal to a given target. The implementation uses the skipTo() method on the subscorers. More...
Public Member Functions inherited from Lucene::Scorer
| Scorer (const SimilarityPtr &similarity)
| Constructs a Scorer. More...
virtual | ~Scorer ()
boost::shared_ptr< Scorer > | shared_from_this ()
SimilarityPtr | getSimilarity ()
| Returns the Similarity implementation used by this scorer. More...
Public Member Functions inherited from Lucene::DocIdSetIterator
virtual | ~DocIdSetIterator ()
boost::shared_ptr< DocIdSetIterator > | shared_from_this ()
Public Member Functions inherited from Lucene::LuceneObject
virtual | ~LuceneObject ()
virtual LuceneObjectPtr | clone (const LuceneObjectPtr &other=LuceneObjectPtr())
| Return clone of this object. More...
virtual int32_t | hashCode ()
| Return hash code for this object. More...
virtual bool | equals (const LuceneObjectPtr &other)
| Return whether two objects are equal. More...
virtual int32_t | compareTo (const LuceneObjectPtr &other)
| Compare two objects. More...
virtual String | toString ()
| Returns a string representation of the object. More...
Public Member Functions inherited from Lucene::LuceneSync
virtual | ~LuceneSync ()
virtual SynchronizePtr | getSync ()
| Return this object synchronize lock. More...
virtual LuceneSignalPtr | getSignal ()
| Return this object signal. More...
virtual void | lock (int32_t timeout=0)
| Lock this object using an optional timeout. More...
virtual void | unlock ()
| Unlock this object. More...
virtual bool | holdsLock ()
| Returns true if this object is currently locked by current thread. More...
virtual void | wait (int32_t timeout=0)
| Wait for signal using an optional timeout. More...
virtual void | notifyAll ()
| Notify all threads waiting for signal. More...

## Static Public Member Functions

static String | _getClassName ()
Static Public Member Functions inherited from Lucene::DisjunctionSumScorer
static String | _getClassName ()
Static Public Member Functions inherited from Lucene::Scorer
static String | _getClassName ()
Static Public Member Functions inherited from Lucene::DocIdSetIterator
static String | _getClassName ()

## Protected Attributes

BooleanScorer2WeakPtr | _scorer
int32_t | lastScoredDoc
double | lastDocScore
Protected Attributes inherited from Lucene::DisjunctionSumScorer
int32_t | nrScorers
| The number of subscorers. More...
Collection< ScorerPtr > | subScorers
| The subscorers. More...
int32_t | minimumNrMatchers
| The minimum number of scorers that should match. More...
ScorerDocQueuePtr | scorerDocQueue
| The scorerDocQueue contains all subscorers ordered by their current doc(), with the minimum at the top. The scorerDocQueue is initialized the first time next() or skipTo() is called. An exhausted scorer is immediately removed from the scorerDocQueue. If less than the minimumNrMatchers scorers remain in the scorerDocQueue next() and skipTo() return false. More...
int32_t | currentDoc
| The document number of the current match. More...
int32_t | _nrMatchers
| The number of subscorers that provide the current match. More...
double | currentScore
Protected Attributes inherited from Lucene::Scorer
SimilarityPtr | similarity
Protected Attributes inherited from Lucene::LuceneSync
SynchronizePtr | objectLock
LuceneSignalPtr | objectSignal

## Additional Inherited Members

Static Public Attributes inherited from Lucene::DocIdSetIterator
static const int32_t | NO_MORE_DOCS
| When returned by nextDoc(), advance(int) and docID() it means there are no more docs in the iterator. More...
Protected Member Functions inherited from Lucene::DisjunctionSumScorer
void | initScorerDocQueue ()
| Called the first time next() or skipTo() is called to initialize scorerDocQueue. More...
virtual bool | score (const CollectorPtr &collector, int32_t max, int32_t firstDocID)
| Collects matching documents in a range. Hook for optimization. Note that next() must be called once before this method is called for the first time. More...
bool | advanceAfterCurrent ()
| Advance all subscorers after the current document determined by the top of the scorerDocQueue. Repeat until at least the minimum number of subscorers match on the same document and all subscorers are after that document or are exhausted. On entry the scorerDocQueue has at least minimumNrMatchers available. At least the scorer with the minimum document number will be advanced. More...
Protected Member Functions inherited from Lucene::LuceneObject
| LuceneObject ()

## Constructor & Destructor Documentation

## ◆ CountingDisjunctionSumScorer()

Lucene::CountingDisjunctionSumScorer::CountingDisjunctionSumScorer | ( | const BooleanScorer2Ptr & | scorer,
|  | Collection< ScorerPtr > | subScorers,
|  | int32_t | minimumNrMatchers
| ) |  |

## ◆ ~CountingDisjunctionSumScorer()

virtual Lucene::CountingDisjunctionSumScorer::~CountingDisjunctionSumScorer | ( |  | ) |

virtual

## Member Function Documentation

## ◆ _getClassName()

static String Lucene::CountingDisjunctionSumScorer::_getClassName | ( |  | ) |

inline static

## ◆ getClassName()

virtual String Lucene::CountingDisjunctionSumScorer::getClassName | ( |  | ) |

inline virtual

Reimplemented from Lucene::DisjunctionSumScorer.

## ◆ score()

virtual double Lucene::CountingDisjunctionSumScorer::score | ( |  | ) |

virtual

Returns the score of the current document matching the query. Initially invalid, until next() is called the first time.

Reimplemented from Lucene::DisjunctionSumScorer.

## ◆ shared_from_this()

boost::shared_ptr< CountingDisjunctionSumScorer > Lucene::CountingDisjunctionSumScorer::shared_from_this | ( |  | ) |

inline

## Field Documentation

## ◆ _scorer

BooleanScorer2WeakPtr Lucene::CountingDisjunctionSumScorer::_scorer

protected

## ◆ lastDocScore

double Lucene::CountingDisjunctionSumScorer::lastDocScore

protected

## ◆ lastScoredDoc

int32_t Lucene::CountingDisjunctionSumScorer::lastScoredDoc

protected

The documentation for this class was generated from the following file:

- BooleanScorer2.h

clucene.sourceforge.net